;********************************************
; FRI FOR FRANSK!                           *
; Marc Klemp (c) 2003,2004,2005             *
;********************************************

;********************************************
; WLA-DX BANKING                            *
;********************************************

.MEMORYMAP
DEFAULTSLOT 0
SLOTSIZE $8000
SLOT 0 $0000
.ENDME

.ROMBANKMAP
BANKSTOTAL 1
BANKSIZE $8000
BANKS 1
.ENDRO

;********************************************
; SDSC-TAG - ROM HEADER                     *
;********************************************

.sdsctag 1.03,"Fri For Fransk!","","Marc Klemp"

.bank 0 slot 0

;********************************************
; BOOT                                      *
;********************************************

.org $0000

   di                                            ; Disable interrupts.
   im 1                                          ; Interrupt mode 1.
   ld sp, $DFF0
   jp Main                                       ; Jump to the "Main" label.

;********************************************
; IRQ                                       *
;********************************************

.org $0038

   push hl

   ld hl, $CC00
   ld a, (hl)
   dec a
   call z, ChangePalette
   ld (hl), a

   ld hl, ($C0D0)
   bit 0, (hl)
   jp z, StopVGM
   pop hl

   in a, ($BF)
   jp UpdateSound

StopVGM:

   pop hl

EndInterrupt:
   reti

;********************************************
; PAUSE INTERRUPT (NMI)                     *
;********************************************

.org $0066
    retn

;********************************************
; MAIN                                      *
;********************************************

Main:

   ld hl, $CC00
   ld (hl), $0f

   call ClearVRAM
   call DisableSprites
   ld hl, FriForFranskPalette
   call LoadPalette
   ld hl, $0000
   call VRAMWriteStart
   call Load3BitsTilesToVRAM
   call LoadTilesFromVRAMToNameTable
   call SetupVDP_Standard
   call TurnOnVDP

   ld de, $C000                                  ; This is where the RAM starts.
   call LoadVGMHeader

   ld hl, $00                                    ; When bit 0 at address $C0D0 is set, the VGM is playing
   ld ($C0D0), hl

   ld hl, FriVGM+$0040                           ; This is where the real VGM data starts

   ei

End_Loop:
   jp End_Loop

;********************************************
; INCLUDES                                  *
;********************************************

.include "Graphics.inc"
.include "Sound.inc"
.include "GFXTitelTiles.inc"
.include "GFXTitelBuild.inc"
.include "Palettes.pal"

FriVGM:
.incbin "Fri.vgm"
